您的位置:首页 > 其它

HDU - 1394 Minimum Inversion Number【逆序数+dp】

2017-09-30 21:18 417 查看


Minimum Inversion Number

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)

Total Submission(s): 21660    Accepted Submission(s): 12952


Problem Description

The inversion number of a given number sequence a1, a2, ..., an is the number of pairs (ai, aj) that satisfy i < j and ai > aj.

For a given sequence of numbers a1, a2, ..., an, if we move the first m >= 0 numbers to the end of the seqence, we will obtain another sequence. There are totally n such sequences as the following:

a1, a2, ..., an-1, an (where m = 0 - the initial seqence)

a2, a3, ..., an, a1 (where m = 1)

a3, a4, ..., an, a1, a2 (where m = 2)

...

an, a1, a2, ..., an-1 (where m = n-1)

You are asked to write a program to find the minimum inversion number out of the above sequences.

 

Input

The input consists of a number of test cases. Each case consists of two lines: the first line contains a positive integer n (n <= 5000); the next line contains a permutation of the n integers from 0 to n-1.

 

Output

For each case, output the minimum inversion number on a single line.

 

Sample Input

10
1 3 6 9 0 8 5 7 4 2

 

Sample Output

16

 
题意:

        求一个数列的逆序数。不断把当前数列的第一个元素移到最后,构成新数列。求所有数列的最小逆序数。

题解:

       可以发现中间的元素不会改变, 由于n个数是0~n-1,那么将第一个数a[0]移到最后时,可以很容易的求出逆序数的改变量。假如a[0]=3,那么后面就有3个比它小的数,他们都要-1,即最终-3;移到末尾后,其前面有6个比它大的数,此时这一位的逆序数为6。那么就可以推出转移方程了:

dp[i]=dp[i-1]-a[i-1]+n-a[i-1]-1;

代码:

#include<stdio.h>
#include<string.h>
#include<algorithm>
using namespace std;
#define inf 1<<29
int n,a[5005],dp[5005];
int cal()
{
int cnt=0;
for(int i=1;i<n;i++)
{
for(int j=0;j<i;j++)
if(a[j]>a[i])
cnt++;
}
return cnt;
}
int main()
{
while(~scanf("%d",&n))
{

for(int i=0;i<n;i++)
scanf("%d",&a[i]);
memset(dp,0,sizeof dp);
dp[0]=cal();
int minn=dp[0];
for(int i=1;i<n;i++)
{
dp[i]=dp[i-1]-a[i-1]+n-a[i-1]-1;
minn=min(minn,dp[i]);
}
printf("%d\n",minn);
}
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息